#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>

#include "serial.h"
#include "macros.h"

#define PIN_LED PA4
#define ADDRESS '4'
#define TIMEOUT_TIME 5000

#define serial_port PORTA
#define serial_direction DDRA
#define serial_pins PINA
#define serial_pin_in (1 << PA0)
#define serial_pin_out (1 << PA1)
#define serial_interrupt (1 << PCIE0)
#define serial_interrupt_pin (1 << PCINT0)

#define MISO PA5
#define MOSI PA6
#define miso_pin (1 << MISO)
#define mosi_pin (1 << MOSI)

int main(void) {
  // set clock divider to /1
  CLKPR = (1 << CLKPCE);
  CLKPR = (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);

  // ADC enabled, flag cleared, prescalar set to 128 (125 kHz)
  ADCSRA = (1 << ADEN) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);
  ADCSRB |= (1 << ADLAR);

  output(DDRA, PIN_LED);

  set(serial_port, serial_pin_out);
  set(serial_direction, serial_pin_out);
  output(serial_direction, serial_pin_out);
  // set(PORTA, PIN_LED);

  static char c;
  while (1) {
    put_char(&serial_port, serial_pin_out, 1);
//        get_char(&serial_pins, miso_pin, &c);
//        put_char(&serial_port, serial_pin_out, c);
  }
}
