#
# hello.HC-SR04.py
#
# HC-SR04 sonar hello-world
#    hello.HC-SR04.py serial_port
#
# Neil Gershenfeld 11/15/15
# (c) Massachusetts Institute of Technology 2015
#
# This work may be reproduced, modified, distributed,
# performed, and displayed for any purpose. Copyright is
# retained and must be preserved. The work is provided
# as is; no warranty is provided, and users accept all
# liability.
#

# from Tkinter import *
import serial
import sys
import time

def main():
    # idle routine
    ser.flush()
    ser.write('4'.encode())
    out = ord(ser.read())
    node = ser.read()
    l = [out, node]
    for i in range(8):
        l.append(ord(ser.read()))
    print(l)
    time.sleep(0.15)  # need to wait until board is ready to receive input
    # p2 = ord(ser.read())
    # print(out, p1)

#  check command line arguments
if (len(sys.argv) != 2):
    print ("command line: hello.HC-SR04.py serial_port")
    sys.exit()
port = sys.argv[1]

# open serial port
ser = serial.Serial(port, 9600)
ser.setDTR()

while 1:
    main()
