#include <avr/interrupt.h>
#include <avr/pgmspace.h>

#define serial_port PORTA
#define serial_direction DDRA
#define serial_pins PINA
#define serial_pin_in (1 << PA0)
#define serial_pin_out (1 << PA1)
#define serial_interrupt (1 << PCIE0)
#define serial_interrupt_pin (1 << PCINT0)

#define MISO PA5
#define MOSI PA6
#define miso_pin (1 << MISO)
#define mosi_pin (1 << MOSI)

#define node_id '4'

#include "thresholding/core.h"

int main(void) {
  // main
  // set clock divider to /1
  CLKPR = (1 << CLKPCE);
  CLKPR = (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);

  // initialize serial pin
  set(serial_port, serial_pin_out);
//  input(serial_direction, serial_pin_out);
  output(serial_direction, serial_pin_out);

  set(serial_port, mosi_pin);
  output(serial_direction, mosi_pin);
  input(serial_direction, miso_pin);

  // main loop
  while (1) {
    put_char(&serial_port, serial_pin_out, 4);
  }


}
